/*//////////////////////////////////////////////////////////////////////////////
Éléments JavaScript pour l'utilisation de base de Cahier de Prépa

Copie partielle de edition.js
//////////////////////////////////////////////////////////////////////////////*/

// Notification de résultat de requête AJAX
function affiche(message,etat) {
  $('#log').removeClass().addClass(etat).html(message).append('<span class="icon-ferme"></span>').fadeIn().off("click").on("click",function() {
    window.clearTimeout(extinction);
    $(this).fadeOut(800);
  });
  extinction = window.setTimeout(function() { $('#log').fadeOut(800); },6000);
}

// Affichage par-dessus le contenu de la page
// * contenu : chaine en HTML qui sera utilisée comme contenu de la fenêtre
// * modal : si true, fenêtre modale (impossible de continuer à éditer la page)
function popup(contenu,modal) {
  // Suppression d'une éventuelle fenêtre de la fonction popup existante
  $('#fenetre,#fenetre_fond').remove();
  // Création
  var el = $('<article id="fenetre"></article>').appendTo('body').html(contenu).focus();
  if ( modal )
    $('<div id="fenetre_fond"></div>').appendTo('body').click(function() {
      $('#fenetre,#fenetre_fond').remove();
    });
  // Si fenêtre non modale, possibilité de l'épingler en haut de la page
  else
    $('<a class="icon-epingle" title="Épingler à la page"></a>').prependTo(el).on("click",function() {
      $('#fenetre_fond').remove();
      $(this).remove();
      el.removeAttr('id').insertBefore($('article,#calendrier,#parentsdoc+*').first());
    });
  // Bouton de fermeture
  $('<a class="icon-ferme" title="Fermer"></a>').prependTo(el).on("click",function() {
    el.remove();
    $('#fenetre_fond').remove();
  });
}


///////////////////
// Requêtes AJAX //
///////////////////
$(document).ajaxSend( function(ev,xhr,settings) {
              $('#load').show(200);
              // Sécurité anti XSS : Ajout du token CSRF
              if ( $('body').attr('data-csrf-token') != undefined )  {
                if ( settings.data.append )
                  settings.data.append('csrf-token',$('body').attr('data-csrf-token'));
                else
                  settings.data = 'csrf-token='+$('body').attr('data-csrf-token')+'&'+settings.data;
              }
            })
           .ajaxStop( function() {
              $('#load').hide(200);
            })
           .ajaxSuccess( function(ev,xhr,settings) {
              var data = xhr.responseJSON;
              switch (data['etat']) {
                // Si ok, on l'affiche dans le log et on lance la "fonction" de mise à jour de l'affichage
                case 'ok':
                  affiche(data['message'],'ok');
                  settings.fonction(settings.el);
                  break;
                // Si non ok, on l'affiche dans le log et on ne fait rien de plus
                case 'nok':
                  affiche(data['message'],'nok');
                  break;
                // Si 'recupok' : récupération de données (pour l'échange de Cahier)
                case 'recupok':
                  settings.afficheform(data);
              }
            });

////////////////////////////////////////////////////////////////////////////
// Modification des éléments (nécessite le chargement complet de la page) //
////////////////////////////////////////////////////////////////////////////
$( function() {

  // Connexion
  $('a.icon-connexion').on('click',function(e) {
    // Div d'affichage des résultats des requêtes AJAX
    if ( !$('#log').length )
      $('<div id="log"></div>').appendTo('body').hide().on("click", function() {
        $(this).hide();
      });

    // Suppression du menu si visible en mode mobile
    if ( $('#menu').hasClass('visible') )
      $('.icon-menu').click();

    // Création de fenêtre
    var el = $('<div id="fenetre"></div>').appendTo('body').html('\
<a class="icon-ferme" title="Fermer"></a><a class="icon-ok" title="Valider"></a><h3>Connexion</h3>\
<form>\
  <p>Veuillez entrer votre identifiant et votre mot de passe&nbsp;:</p>\
  <input class="ligne" type="text" name="login" placeholder="Identifiant">\
  <input class="ligne" type="password" name="motdepasse" placeholder="Mot de passe">\
  <p class="oubli"><label for="permconn">Se souvenir de moi</label><input type="checkbox" name="permconn" id="permconn" value="1">\
  <p class="oubli"><a href="gestioncompte?oublimdp">Identifiant ou mot de passe oublié&nbsp;?</a></p>\
  <p class="oubli"><a href="gestioncompte?creation">Créer un compte</a></p>\
</form>');
    // Fond grisé
    $('<div id="fenetre_fond"></div>').appendTo('body').click(function() {
      $('#fenetre,#fenetre_fond').remove();
    });
    // Bouton de fermeture
    $('#fenetre a.icon-ferme').on("click",function() {
      $('#fenetre,#fenetre_fond').remove();
    });
    // Envoi
    $('#fenetre a.icon-ok').on("click",function () {
      $.ajax({url: 'ajax.php',
              method: "post",
              data: $('#fenetre form').serialize()+'&connexion=1', 
              dataType: 'json', 
              el: '', 
              beforeSend: function() { $('#load').show(200); },
              complete: function() { $('#load').hide(200); },
              fonction: function(el) { location.reload(true); } 
            }).done( function(data) {
              // Si erreur d'identification, on reste bloqué là
              if ( data['etat'] == 'nok' )
                $('#fenetre form p:first').html(data['message']).addClass('warning');
            });
    });
    // Envoi par appui sur Entrée
    $('#fenetre input').on('keypress',function (e) {
      if ( e.which == 13 ) {
        $('#fenetre a.icon-ok').click();
        return false;
      }
    });
    // Focus initial
    $('#fenetre form input:first').focus();
  });

  // Déconnexion  
  $('a.icon-deconnexion').on('click',function(e) {
    $.ajax({url: 'ajax.php', method: "post", data: { action:'deconnexion' }, dataType: 'json', el: '', fonction: function(el) { location.reload(true); } });
  });

  // Affichage des informations sur le flux RSS
  $('a.icon-rss').on("click", function() { popup($('#aide-rss').html(),false); });

  // Menu mobile
  $('.icon-menu').on("click", function(e) {
    e.stopPropagation();
    $('#menu').toggleClass('visible');
    if ( $('#menu').hasClass('visible') )  {
      $('<div id="menu_fond"></div>').appendTo('body');
      $('#menu,#menu_fond').on("click", function() {
        $('#menu_fond').remove();
        $('#menu').removeClass('visible');
      });
    }
    else 
      $('#menu_fond').remove();
  });

  // Pop-up pour les événements de l'agenda
  $('.evnmt').on("click", function() {
    var donnees = evenements[this.id.substr(1)];
    var el = $('<div id="fenetre"></div>').appendTo('body').html('<h3>'+donnees.titrebis+'</h3>\n<h3 style="margin-bottom: 1em;">'+donnees.date+'</h3>\n<p>'+donnees.texte+'</p>').focus();
    $('<div id="fenetre_fond"></div>').appendTo('body').click(function() {
      $('#fenetre,#fenetre_fond').remove();
    });
    $('<a class="icon-ferme" title="Fermer"></a>').prependTo(el).on("click",function() {
      el.remove();
      $('#fenetre_fond').remove();
    });
  });
  
  // Changement de Cahier si interface globale et si compte global existant contenant au moins un autre Cahier
  $('a.icon-echange').on("click",function() {
    $.ajax({url: 'recup.php',
            method: "post",
            data: { action:'compteglobal' },
            dataType: 'json',
            afficheform: function(data) {
              popup('<h3>Changer de Cahier</h3><div></div><p>Cette liste est éditable sur l\'<a href="/connexion/">interface de connexion globale</a>.</p>',true);
              var f = $('#fenetre');
              // Récupération des valeurs et écriture 
              var cahiers = data['cahiers'];
              for ( var rep in cahiers )
                $('div',f).attr('id','cahiers').append('<a href="/'+rep+'/">'+cahiers[rep]+'</a>');
            }
    });
  });

});
